unit ufrmMain;

interface

uses
  Forms
  , ufrmBase
  , Controls
  , Grids
  , DBGrids
  , DB
  , ComCtrls
  , ToolWin
  , StdCtrls
  , Mask
  , DBCtrls
  , DBActns
  , Classes
  , ActnList
  , ImgList
  ;

type
  TfrmMain = class(TfrmBase)
    Label2: TLabel;
    DBEdit1: TDBEdit;
    Label3: TLabel;
    DBEdit2: TDBEdit;
    Label4: TLabel;
    DBEdit3: TDBEdit;
    Label5: TLabel;
    DBEdit4: TDBEdit;
    Label6: TLabel;
    DBEdit5: TDBEdit;
    Label7: TLabel;
    DBEdit6: TDBEdit;
    Label8: TLabel;
    DBEdit7: TDBEdit;
    Label9: TLabel;
    DBEdit8: TDBEdit;
    Label10: TLabel;
    DBEdit9: TDBEdit;
    Label11: TLabel;
    DBEdit10: TDBEdit;
    Label12: TLabel;
    DBEdit11: TDBEdit;
    Label13: TLabel;
    DBEdit12: TDBEdit;
    actInsOrder: TDataSetInsert;
    actOrders: TAction;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    cmdDone: TButton;
    cmdMasterDetail: TButton;
    procedure FormCreate(Sender: TObject);
    procedure actOrdersExecute(Sender: TObject);
    procedure cmdDoneClick(Sender: TObject);
    procedure cmdMasterDetailClick(Sender: TObject);
  private
    { Private declarations }
  protected

    procedure SetDM(const Value: TDataModule); override;

  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses
  udmCustomers
  , udmCustomersGUI
  , SysUtils
  , ufrmOrders
  , ufrmMasterDetail
  ;

{$R *.dfm}

procedure TfrmMain.SetDM(const Value: TDataModule);
begin
  // Point to the relevant dataset & open it
  if Value is TdmCustomers then
  begin
    inherited;
    DSMain.DataSet := TdmCustomers(Value).Customer;
    if not TdmCustomers(Value).Customer.Active then
      TdmCustomers(Value).Customer.Open;
  end
  else
  begin
    raise Exception.Create('The main form needs a Customer data module');
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  DM := TdmCustomersGUI.Create(Self);
end;

procedure TfrmMain.actOrdersExecute(Sender: TObject);
var
  frmOrders: TfrmOrders;
begin
  frmOrders := TfrmOrders.Create(Self);
  try
    frmOrders.DM := DM;
    frmOrders.ShowModal;
  finally
    frmOrders.Release;
  end;
end;

procedure TfrmMain.cmdDoneClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.cmdMasterDetailClick(Sender: TObject);
var
  frm: TfrmMasterDetail;
begin
  frm := TfrmMasterDetail.Create(Self);
  try
    frm.ShowModal;
  finally
    frm.Release;
  end;

end;

end.
